from PyQt4 import QtCore, QtGui

from core.auimd_widget import *

class DialogContainer(QtGui.QWidget, AuimdWidget):
  def __init__(self, parent, dialog, title, left_button_text, right_button_text, icon):
    QtGui.QWidget.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.loop=None
    self.result=None
    self.dialog=dialog
    self.dialog_old_parent=dialog.parent()
    self.dialog.setParent(self)

    self.left_button.setText(left_button_text)
    self.right_button.setText(right_button_text)
    
    self.widget_title=title
    self.widget_icon=icon

    self.connect(self.dialog, QtCore.SIGNAL("finished(int)"), self.onFinished)

  def resizeEvent(self, e):
    self.dialog.setGeometry(0, 0, e.size().width(), e.size().height())

  def exec_(self):
    self.loop=QtCore.QEventLoop(self.dialog)
    self.loop.exec_()
    self.dialog.hide()
    self.dialog.setParent(self.dialog_old_parent)
    
    return self.result

  def onFinished(self, result):
    self.result=result
    self.loop.exit()

  def leftButtonAction(self):
    self.dialog.accept()

  def rightButtonAction(self):
    self.dialog.reject()

  def closeEvent(self, e):
    if self.loop: 
      self.result=None
      self.loop.exit()
