from PyQt4 import QtCore, QtGui

from core.auimd_widget import *

class Dialog(QtGui.QWidget, AuimdWidget):
  @staticmethod
  def defaultWidgetTitle():
    return "Sample dialog"

  # a simple dialog, could also be done with designer
  class MyDialog(QtGui.QDialog):
    def __init__(self):
      QtGui.QDialog.__init__(self)

      # widgets
      self.msg=QtGui.QLabel("Choose Yes or No :", self)
      self.y=QtGui.QPushButton("Yes", self)
      self.n=QtGui.QPushButton("No", self)

      # layouts
      hl=QtGui.QHBoxLayout()
      hl.addWidget(self.y)
      hl.addWidget(self.n)
      vl=QtGui.QVBoxLayout(self)
      vl.addWidget(self.msg)
      vl.addLayout(hl)

      # connections
      self.connect(self.y, QtCore.SIGNAL("clicked()"), self.accept)
      self.connect(self.n, QtCore.SIGNAL("clicked()"), self.reject)

  def __init__(self, parent, *args):
    QtGui.QWidget.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    # create a button and a label and put them in a layout
    self.result=QtGui.QLabel("Nothing choosed", self)
    self.b=QtGui.QPushButton("Choose...", self)
    layout=QtGui.QVBoxLayout(self)
    layout.addWidget(self.b)
    layout.addWidget(self.result)

    self.connect(self.b, QtCore.SIGNAL("clicked()"), self.onClicked)

  def onClicked(self):
    # open a dialog box
    d=self.MyDialog()
    res=self.desktop.dialog(self, d, "Choose..")
    if res==None:
      self.result.setText("Nothing choosed")
    elif res==QtGui.QDialog.Accepted:
      self.result.setText("Choosed 'Yes'")
    else:
      self.result.setText("Choosed 'No'")

