from PyQt4 import QtCore, QtGui, uic

from . import __path__

(Ui_IncomingCall, IncomingCallBaseClass) = uic.loadUiType(__path__[0]+"/ui/incoming_call.ui")
(Ui_OutgoingCall, OutgoingCallBaseClass) = uic.loadUiType(__path__[0]+"/ui/outgoing_call.ui")
(Ui_CallInProgress, CallInProgressBaseClass) = uic.loadUiType(__path__[0]+"/ui/call_in_progress.ui")

class CallInProgress(CallInProgressBaseClass, Ui_CallInProgress):
  def __init__(self, parent):
    CallInProgressBaseClass.__init__(self, parent)
    self.setupUi(self)

class OutgoingCall(OutgoingCallBaseClass, Ui_OutgoingCall):
  def __init__(self, parent):
    OutgoingCallBaseClass.__init__(self, parent)
    self.setupUi(self)

class IncomingCall(IncomingCallBaseClass, Ui_IncomingCall):
  def __init__(self, parent):
    IncomingCallBaseClass.__init__(self, parent)
    self.setupUi(self)

class CallUi(QtGui.QStackedWidget):
  def __init__(self, parent, call):
    QtGui.QStackedWidget.__init__(self, parent)
  
    self.call=call

    self.call_in_progress=CallInProgress(self)
    self.call_in_progress.who.setText(call.peer)
    self.addWidget(self.call_in_progress)
    self.connect(self.call_in_progress.hangup, QtCore.SIGNAL("clicked()"), self.onHangupClicked)
    if call.type==call.INCOMING:
      self.incoming=IncomingCall(self)
      self.addWidget(self.incoming)
      self.incoming.who.setText(call.peer)
      self.connect(self.incoming.accept_call, QtCore.SIGNAL("clicked()"), self.onAcceptCallClicked)
      self.connect(self.incoming.reject_call, QtCore.SIGNAL("clicked()"), self.onRejectCallClicked)
      self.setCurrentWidget(self.incoming)
    else:
      self.outgoing=OutgoingCall(self)
      self.addWidget(self.outgoing)
      self.outgoing.who.setText(call.peer)
      self.connect(self.outgoing.cancel, QtCore.SIGNAL("clicked()"), self.onCancelClicked)
      self.setCurrentWidget(self.outgoing)

  def onAcceptCallClicked(self):
    self.emit(QtCore.SIGNAL("callAccepted"), self.call)
    self.incoming.accept_call.setEnabled(False)
    self.incoming.reject_call.setEnabled(False)

  def onRejectCallClicked(self):
    self.emit(QtCore.SIGNAL("callEnded"), self.call)
    self.incoming.accept_call.setEnabled(False)
    self.incoming.reject_call.setEnabled(False)

  def onHangupClicked(self):
    self.emit(QtCore.SIGNAL("callEnded"), self.call)
    self.call_in_progress.hangup.setEnabled(False)

  def onCancelClicked(self):
    self.emit(QtCore.SIGNAL("callEnded"), self.call)
    self.outgoing.cancel.setEnabled(False)

  def setStatus(self, status):
    if status=="active":
      self.setCurrentWidget(self.call_in_progress)
