from PyQt4 import QtCore, QtGui, uic

from . import __path__
from core.auimd_widget import *

(Ui_WebBrowser, BaseClass) = uic.loadUiType(__path__[0]+"/ui/webbrowser.ui")

class WebBrowser(Ui_WebBrowser, BaseClass, AuimdWidget):
  @staticmethod
  def defaultWidgetIcon():
    return QtGui.QIcon(__path__[0]+"/icons/package_network.png")

  @staticmethod
  def defaultWidgetTitle():
    return "Web Browser"

  @staticmethod
  def getCategory():
    return "Network"

  def __init__(self, parent, *args):
    BaseClass.__init__(self, parent)
    AuimdWidget.__init__(self, parent)

    self.loading=0

    self.setupUi(self)

    self.back.setEnabled(0)
    self.forward.setEnabled(0)

    self.left_button.setText("Menu...")
    self.right_button.setText("Close")

    if len(args):
      start_url=args[0]
    else:
      start_url="about:blank"
    self.web_view.load(QtCore.QUrl(start_url))

  def leftButtonAction(self):
    pass

  def rightButtonAction(self):
    self.desktop.closeWidget(self)

  def okCancelActivated(self):
    if self.loading:
      self.web_view.stop()
    else:
      u=self.url.text()
      if not ':' in u:
        self.url.setText("http://"+u)
      self.web_view.load(QtCore.QUrl(self.url.text()))

  def urlValidated(self):
    u=self.url.text()
    if not ':' in u:
      self.url.setText("http://"+u)
    self.web_view.setUrl(QtCore.QUrl(self.url.text()))

  def loadStarted(self):
    self.loading=1
    self.ok_cancel.setIcon(QtGui.QIcon(__path__[0]+"/icons/cancel.png"))
    self.back.setEnabled(self.web_view.history().canGoBack())

  def loadFinished(self, ok):
    self.loading=0
    self.ok_cancel.setIcon(QtGui.QIcon(__path__[0]+"/icons/ok.png"))
    self.forward.setEnabled(self.web_view.history().canGoForward())

  def urlChanged(self, url):
    self.url.setText(url.toString())
